-- =============================================
-- Author:		FID.Ridwan
-- Create date: 2019-03-20
-- Description:	
-- =============================================
CREATE PROCEDURE [dbo].[SP_CED_SEND_RECEIVING]
AS
BEGIN
	-- Update IPPCS.TB_R_DELIVERY_CTL_D
	UPDATE D
	SET D.ARRIVAL_GATE_DT = T.ARRIVAL_GATE_DT
		,D.ARRIVAL_ACTUAL_DT = T.ARRIVAL_ACTUAL_DT
		,D.ARRIVAL_STATUS = T.ARRIVAL_STATUS
		,D.ARRIVAL_GAP = T.ARRIVAL_GAP
		,D.DEPARTURE_ACTUAL_DT = T.DEPARTURE_ACTUAL_DT
		,D.DEPARTURE_STATUS = T.DEPARTURE_STATUS
		,D.DEPARTURE_GAP = T.DEPARTURE_GAP
		,D.REMAINING = T.REMAINING
		,D.CHANGED_BY = T.CREATED_BY
		,D.CHANGED_DT = GETDATE()
	FROM TB_R_DELIVERY_CTL_D D
	JOIN (
		SELECT DISTINCT DELIVERY_NO
			,DOCK_CD
			,ARRIVAL_GATE_DT
			,ARRIVAL_ACTUAL_DT
			,ARRIVAL_STATUS
			,ARRIVAL_GAP
			,DEPARTURE_ACTUAL_DT
			,DEPARTURE_STATUS
			,DEPARTURE_GAP
			,REMAINING
			,CREATED_BY
		FROM TB_T_CED_SEND_DELIVERY_DCL
		) T ON D.DELIVERY_NO = T.DELIVERY_NO
		AND D.DOCK_CD = T.DOCK_CD
		
	-- FID.Ridwan 2019-10-15 : change logic delivery status
	SELECT DISTINCT B.DELIVERY_NO, 'PARTIAL' AS TYPE
	INTO #TB_T_LIST_DELIVERY_NO
	FROM TB_T_CED_SEND_DELIVERY_DCL A 
	JOIN TB_R_DELIVERY_CTL_D B ON A.DELIVERY_NO = B.DELIVERY_NO
	WHERE ISNULL(B.DEPARTURE_ACTUAL_DT,'') = ''
	
	-- Updata IPPCS.TB_R_DELIVERY_CTL_H
	UPDATE H
	SET --H.DELIVERY_STS = T.DELIVERY_STS
		H.DELIVERY_STS = CASE WHEN CC.TYPE = 'PARTIAL' THEN 'Arrived' ELSE 'Delivered' END
		,H.CHANGED_BY = T.CREATED_BY
		,H.CHANGED_DT = GETDATE()
	FROM TB_R_DELIVERY_CTL_H H
	JOIN (
		SELECT DISTINCT DELIVERY_NO
			,DELIVERY_STS
			,CREATED_BY
		FROM TB_T_CED_SEND_DELIVERY_DCL
		) T ON H.DELIVERY_NO = T.DELIVERY_NO
	LEFT JOIN #TB_T_LIST_DELIVERY_NO CC ON H.DELIVERY_NO = CC.DELIVERY_NO

	--Update Finish Flag
	UPDATE TB_T_CED_SEND_DELIVERY_DCL
	SET FINISH_FLAG = 'Y'
		,FINISH_DATE = GETDATE()

	-- Update IPPCS.TB_R_DAILY_ORDER_PART
	UPDATE P
	SET P.RECEIVED_STATUS = '1'
		,P.CHANGED_BY = T.CREATED_BY
		,P.CHANGED_DT = GETDATE()
	FROM dbo.TB_R_DAILY_ORDER_PART P
	JOIN (
		SELECT DISTINCT T.MANIFEST_NO
			,T.CREATED_BY
		FROM TB_T_CED_SEND_RECEIVING T
		) T ON T.MANIFEST_NO = P.MANIFEST_NO

	-- Update IPPCS.TB_R_DAILY_ORDER_MANIFEST
	UPDATE M
	SET M.RECEIVE_FLAG = '1'
		,M.RECEIVE_DT = T.MANIFEST_RECEIVING_DT
		,M.ARRIVAL_ACTUAL_DT = T.MANIFEST_RECEIVING_DT
		,M.MANIFEST_RECEIVE_FLAG = '2'
		,M.DROP_STATUS_FLAG = '1'
		,M.DROP_STATUS_DT = T.MANIFEST_RECEIVING_DT
		,M.CHANGED_BY = T.CREATED_BY
		,M.CHANGED_DT = GETDATE()
	FROM dbo.TB_R_DAILY_ORDER_MANIFEST M
	JOIN (
		SELECT DISTINCT T.MANIFEST_NO
			,T.MANIFEST_RECEIVING_DT
			,T.CREATED_BY
		FROM TB_T_CED_SEND_RECEIVING T
		) T ON T.MANIFEST_NO = M.MANIFEST_NO

	--Update Finish Flag
	UPDATE TB_T_CED_SEND_RECEIVING
	SET FINISH_FLAG = 'Y'
		,FINISH_DATE = GETDATE()

	DROP TABLE #TB_T_LIST_DELIVERY_NO
END

